'''
===============================================================
===============================================================
buildFromCfg
===============================================================
===============================================================
'''

from panda3d.core import PandaNode, NodePath, StringStream
import guiObjects
import guiActionCstm
import guiActionLib
   
#****************************************************************************
def buildFromEgg(self, egg_path, LayoutList):
   obj_bank={}
   #_________loading gui template____________________________________________
   pn=loader.loadModel(egg_path).node() # raise IOError if path is wrong
   numerator=0
   nodes_list=[]
   getNodes(pn, nodes_list)
   #_______name unnamed nodes for search preposes____________________________
   for node in nodes_list:
      if node.hasName(): continue
      else:
         node.setName(str(pn_child.getClassType())+str(numerator))
         numerator+=1
   #_______remove geom info from layout______________________________________
   __delLayoutGeom(nodes_list)
   #_______explode hierarchy_________________________________________________
   __treeExplode (obj_bank,nodes_list)
   del nodes_list
   #_______mixing pandanode and geomnode of -< node
   __mixGnPn (obj_bank)
   #_______create controls___________________________________________________
   __setupControls(obj_bank)
   #_______resurect tree_____________________________________________________
   __treeResurect(obj_bank)
   #_______return layouts____________________________________________________
   num_children=pn.getNumChildren()
   for indx in range(num_children):
      pn_child=pn.getChild(indx)
      if  'layout' in str(pn_child.getName()):
         layout_name=str(pn_child.getName())
         LayoutList.update({layout_name:pn_child})
         pn.removeChild(pn_child)
   xxxxxx
#****************************************************************************
def __delLayoutGeom(nodes_list):
   layout_geoms=[]
   for node in node_list:
      if 'layout' in node.getName():
         layout_children=node.getNumChildren()
         for indx in range(layout_children):
            layout_child=node.getChild(indx)
            if layout_child.isGeomeNode(): 
               layout_geoms.append(layout_child)
               node.removeChild(layout_child)
   for node in layout_geoms:
      nodes_list.remove(node)
                     
#****************************************************************************
def getNodes(pn, nodes_list):
   if not len(nodes_list): nodes_list.append(pn)
   num_children=pn.getNumChildren()
   if not num_children: return
   for indx in range(num_children):
      nodes_list.append(pn.getChild(indx))
   for indx in range(num_children):
      self.getNodes(pn=pn.getChild(indx), nodes_list=nodes_list)
#****************************************************************************
def __treeExplode(obj_bank, nodes_list):
   for node in nodes_list:
      obj_name=node.getName()
      obj_prnt=node.getParent(0).getName() if node.getNumParents() else None
      #obj_bank={obj_name:{'obj':pn, 'prnt':obj_prnt}}
      obj_bank[obj_name]={'obj':node, 'prnt':obj_prnt}
   for node in nodes_list:
      node.removeAllChildren()
#****************************************************************************
def __treeExplode2(obj_bank, pn):
   obj_name=pn.getName()
   obj_prnt=pn.getParent(0).getName() if pn.getNumParents() else None
   #obj_bank={obj_name:{'obj':pn, 'prnt':obj_prnt}}
   obj_bank[obj_name]={'obj':pn, 'prnt':obj_prnt} 
   num_children=pn.getNumChildren()
   if not num_children: return
   for indx in range(num_children):
      pn_child=pn.getChild(indx)
      treeExplode2(obj_bank, pn_child)
   pn.removeAllChildren()
#****************************************************************************
def __mixGnPn(obj_bank):
   old_nodes=[]
   new_nodes={}
   for gn_name, gn_dict in obj_bank.iteritems() :
      if 'GeomNode' in str(gn_name):
         pn_name=gn_dict['prnt']
         pn_dict=obj_bank[pn_name] #get name of extra PandaNode 
         pn=pn_dict['obj']
         if pn.isGeomNode(): continue # GeomNode under GeomNode - ok
         # mixing PandaNode and GeomNode
         #_______PandaNodeName______GeomNode data_______hierarchy info_____
         gn_dict={pn_name:{'obj':gn_dict['obj'],'prnt':pn_dict['prnt']}}
         gn=tmp[pn_name]['obj']
         #____remember current Geom and his parent______
         if gn_name not in old_nodes: old_nodes.append(gn_name)
         if pn_name not in old_nodes: old_nodes.append(pn_name)
         gn.setName(pn_name)
         gn.copyTags(pn)
         gn.setTransform(pn.getTransform())
         #____create bank of corrected nodes for replacement________
         new_nodes.update(gn_dict)
   #___remove old nodes____         
   for itm in old_nodes:
      obj_bank.pop(itm)
   #___add new correct nodes____
   obj_bank.update(new_nodes)

#****************************************************************************
def __treeResurect(obj_bank):
   for node in obj_bank.itervalues():
      if node['prnt']==None:
         continue
      else: node['obj'].reparentTo(obj_bank[node['prnt']]['obj'])

#****************************************************************************
def __setupControls(obj_bank):
   for np_name, np_dict in obj_bank.iteritems():
      np_dict['obj']=NodePath(np_dict['obj'])
      if 'layout' in np_name:
         np_dict['obj']=__setupLayout(np_dict['obj'])
      if 'pnl' in np_name:
         np_dict['obj']=NodePath(__setupPanel(np_dict['obj']))
      if 'btn' in np_name:
         np_dict['obj']=NodePath(__setupButton(np_dict['obj']))
      if 'scroll' in np_name:
         np_dict['obj']=NodePath(__setupScrollbar(np_dict['obj']))
      if 'entry' in np_name:
         np_dict['obj']=NodePath(__setupEntry(np_dict['obj']))
#****************************************************************************
def getPnTags(pn):
   tmp_str=out=StringStream()
   pn.listTags(tmp_str)
   return tmp_str.getData().split()
#****************************************************************************
def __setupLayout(np):
   effectList={}
   tags=getPnTags(np.node())
   for tag in tags:
      #____format of effect tag of model: 'effect_functionname'_____________
      #____functionname must exist in guiActionCstm.py or guiActionLib.py___
      if 'effect' in tag:
         func=tag.split('_')[1]
         effectList.update({func:guiActionCstm[func]})
   return guiObjects.Layout(np, effectList)
#***************************************************************************
def __setupPanel(np):
   effectList={}
   tags=getPnTags(np.node())
   for tag in tags:
      #____format of effect tag of model: 'effect_functionname'_____________
      #____functionname must exist in guiActionCstm.py or guiActionLib.py___
      if 'effect' in tag:
         func=tag.split('_')[1]
         effectList.update({func:guiActionCstm[func]})
   return guiObjects.Panel(np, effectList)
#****************************************************************************




def __selectLayouts(self, np_base=None):
   print np_base.getName()
   layouts=[]
   if 'layout' in np_base.getName():
      layouts.append(np_base)
   np_children=np_base.getChildren().getPaths()
   if len(np_children)==0:
      return layouts
   for itm in range(np_children):
      layouts=layouts+self._selectLayouts(np_base=itm)
      print layouts,'+',self._selectLayouts(np_base=itm)
   return layouts
