'''
===============================================================
===============================================================
buildFromCfg
===============================================================
===============================================================
'''

from panda3d.core import PandaNode, NodePath
from guiObjects import *

   
def getAllChildren(self, pn, nodes_list):
   if type(pn)==type(PandaNode) and type(nodes_list)==type([]):
      num_children=pn.getNumChildren()
      if not num_children: return
      for indx in num_children:
         nodes_list.append(pn.getChild(indx))
      for indx in num_children:
         self.getAllChildren(pn=pn.getChild(indx), nodes_list=nodes_list)
#****************************************************************************
def buildFromEgg(self, egg_path, LayoutList):
   obj_bank={}
   #_________loading gui template____________________________________________
   pn=loader.loadModel(egg_path).node() # raise IOError if path is wrong
   num_children=pn.getNumChildren()
   numerator=0
   #_______name unnamed nodes for search preposes____________________________
   #only extra nodes have no name, unnamed GeomNode under PandaNode - wrong
   for indx in range(num_children):
      pn_child=pn.getChild(indx)
      if pn_child.hasName(): continue
      else:
         pn_child.setName(str(pn_child.getClassType())+str(numerator))
         numerator+=1
   #_______explode hierarchy_________________________________________________
   __treeExplode (obj_bank, pn)
   #_______collapse linked pandanode geomnode 
   __treePack (obj_bank)
   #_______create controls___________________________________________________
   __setupControls(obj_bank)
   #_______resurect tree_____________________________________________________
   __treeResurect(obj_bank)
   #_______return layouts____________________________________________________
   num_children=pn.getNumChildren()
   for indx in range(num_children):
      pn_child=pn.getChild(indx)
      if  'layout' in str(pn_child.getName()):
         layout_name=str(pn_child.getName())
         LayoutList.update({layout_name:pn_child})
         pn.removeChild(pn_child)
   xxxxxx
         
      
#***************************************************************************
def __treeExplode(obj_bank, pn):
   obj_name=str(pn.getName())
   obj_prnt=str(pn.getParent(0).getName()) if pn.getNumParents() else None
   #obj_bank={obj_name:{'obj':pn, 'prnt':obj_prnt}}
   obj_bank[obj_name]={'obj':pn, 'prnt':obj_prnt} 
   num_children=pn.getNumChildren()
   if not num_children: return
   
   for indx in range(num_children):
      pn_child=pn.getChild(indx)
      treeExplode(obj_bank, pn_child)
   pn.removeAllChildren()
#***************************************************************************
def __treePack(obj_bank):
   old_nodes=[]
   new_nodes={}
   for gn_name, gn_dict in obj_bank.iteritems() :
      if 'GeomNode' in str(gn_name):
         pn_name=gn_dict['prnt']
         pn_dict=obj_bank[pn_name] #get name of extra PandaNode 
         pn=pn_dict['obj']
         if pn.isGeomNode(): continue # GeomNode under GeomNode - ok
         # mixing PandaNode and GeomNode
         #_______PandaNodeName______GeomNode data_______hierarchy info_____
         gn_dict={pn_name:{'obj':gn_dict['obj'],'prnt':pn_dict['prnt']}}
         gn=tmp[pn_name]['obj']
         #____remember current Geom and his parent______
         if gn_name not in old_nodes: old_nodes.append(gn_name)
         if pn_name not in old_nodes: old_nodes.append(pn_name)
         gn.setName(pn_name)
         gn.copyTags(pn)
         gn.setTransform(pn.getTransform())
         #____create bank of corrected nodes for replacement________
         new_nodes.update(gn_dict)
   #___remove old nodes____         
   for itm in old_nodes:
      obj_bank.pop(itm)
   #___add new correct nodes____
   obj_bank.update(new_nodes)

#**************************************************************************
def __treeResurect(obj_bank):
   for node in obj_bank.itervalues():
      node['obj']=NodePath(node['obj'])
   for node in obj_bank.itervalues():
      if node['prnt']==None:
         continue
      else: node['obj'].reparentTo(obj_bank[node['prnt']]['obj'])

#***************************************************************************
def __setupControls(obj_bank):
   for np_name, np_dict in obj_bank.iteritems():
      if 'layout' in np_name:
         __setupLayout(np_name, np_dict['obj'],np_prnt)
      if 'pnl' in np_name:
         __setupPanel(np_name, np_dict['obj'],np_prnt)
      if 'btn' in np_name:
         __setupButton(np_name, np_dict['obj'],np_prnt)
      if 'scroll' in np_name:
         __setupScrollbar(np_name, np_dict['obj'],np_prnt)
      if 'entry' in np_name:
         __setupEntry(np_name, np_dict['obj'],np_prnt)
#***************************************************************************
def buildFromDat(self, egg_path, LayoutList):
   pass

def buildFromCfg(self, egg_path, LayoutList):
   pass

def __selectLayouts(self, np_base=None):
   print np_base.getName()
   layouts=[]
   if 'layout' in np_base.getName():
      layouts.append(np_base)
   np_children=np_base.getChildren().getPaths()
   if len(np_children)==0:
      return layouts
   for itm in range(np_children):
      layouts=layouts+self._selectLayouts(np_base=itm)
      print layouts,'+',self._selectLayouts(np_base=itm)
   return layouts
