import copy as pyCopy
from panda3d.core import PGButton, MouseButton, NodePath, PandaNode
from panda3d.core import BoundingVolume, Texture, PNMImage
from direct.showbase.DirectObject import DirectObject
import guiBuildFromEGG, guiBuildFromData

#****global section ********************************************************
__mouseBtn={'mouse1':MouseButton.one(),
        'mouse2':MouseButton.two(),
        'mouse3':MouseButton.Tree()}

#***************************************************************************
class Layout(NodePath):
   def __init__(self, np, effectList):
      NodePath.__init__(self)
      self=pyCopy.copy(np)
      self.effectList.update(effectList) #{}
   #______ first param of effect func recives layout object_________________
   def runEffect (self, effect):
      self.effectList[effect](self)
   def addPanel(self, file_path):
      pass  
#***************************************************************
class guiButton(DirectObject, PGButton):
   def __init__(self, np=None):
      if np is None: return
      state_data={'ready':NodePath(np),'depressed':NodePath(np),
                  'rollover':NodePath(np),'inactive':NodePath(np)}
      tex_ready=state_data['ready'].findTexture('**')
      tex_path=str(tex_ready.getFilename()).split('/')#[]
      tex_name=tex_path[-1].split('_')#[]
      #rul - c:/folder/namebase_suffix.(png|jpg...)
      for sufx in ('depressed','rollover','inactive'):
         new_name=tex_name[0]+'_'+ sufx +tex_name[1][-4:]#str
         new_path=tex_path[:-1]+[new_name]
         new_path=string.join(new_path,'/')
         new_tex=tex.makeCopy()
         try:
            new_tex.read(tex_path)
         except AssertionError: continue
         new_np=state_data['ready'].copyTo(NodePath())
         new_np.detachNode()
         new_np.setTexture(new_tex)
         state_data[Sufx]=new_np
         
      DirectObject.__init__(self)
      PGButton.__init__(self,'')
      self.setName(np.getName())
      self.setup(state_data['ready'],state_data['depressed'],
                 state_data['rollover'],state_data['inactive']) 
      #node must have tags: click_(mouse1|mouse2|...)=function_name
      for btn in ('mouse1','mouse2','mouse3'):
         tag='click_'+btn
         if np.hasTag(tag):
            event_func=guiActionC[np.getTag(tag)]
         else:
            event_func=guiActionL['clickGuiButton']
         self.accept (self.getClickEvent(__mouseBtn[btn]), event_func)
      

#***************************************************************************
class guiPanel(DirectObject, PGButton):
   def __init__(self, np, effectList):

      PGButton.__init__(name)

   def addComponent(self):
      pass

   def _addPanel(self):
      pass
   
   def _addButton(self):
      pass

   def _addEntry(self):
      pass

   def _addRadioButton(self):
      pass

   def _addCheckBox(self):
      pass

#**************************************************************
class guiEntry(DirectObject, PGButton):
   def __init__(self, parent=None, name='unnamed', pos=VBase3(0,0,0), status=True, action=None):
      PGEntry.__init__(name)
      
      self.accept (self, self.getClickEvent(Button[0]), action, [])
      self.accept (self, self.getClickEvent(Button[1]), _B2_resend, [parent])
      self.accept (self, self.getClickEvent(Button[2]), _B3_resend, [parent])
      
   def _B2_resend(self, parent):
      p_event=parent.getPressEvent (Button[1])
      event...(p_event)
      
   def _B3_resend(self, parent):
      p_event=parent.getPressEvent (Button[2])
      event...(p_event)

#**************************************************************
class guiSliderBar(DirectObject, PGButton):
   def __init__(self, parent=None, name='unnamed', pos=VBase3(0,0,0), status=True, action=None):
      PGSliderBar.__init__(name)
      
      self.accept (self, self.getClickEvent(Button[0]), action, [])
      self.accept (self, self.getClickEvent(Button[1]), _B2_resend, [parent])
      self.accept (self, self.getClickEvent(Button[2]), _B3_resend, [parent])
      
   def _B2_resend(self, parent):
      p_event=parent.getPressEvent (Button[1])
      event...(p_event)
      
   def _B3_resend(self, parent):
      p_event=parent.getPressEvent (Button[2])
      event...(p_event)

#**************************************************************
class guiScrollFrame(DirectObject, PGButton):
   def __init__(self, parent=None, name='unnamed', pos=VBase3(0,0,0), status=True, action=None):
      PGScrollFrame.__init__(name)
      
      self.accept (self, self.getClickEvent(Button[0]), action, [])
      self.accept (self, self.getClickEvent(Button[1]), _B2_resend, [parent])
      self.accept (self, self.getClickEvent(Button[2]), _B3_resend, [parent])
      
   def _B2_resend(self, parent):
      p_event=parent.getPressEvent (Button[1])
      event...(p_event)
      
   def _B3_resend(self, parent):
      p_event=parent.getPressEvent (Button[2])
      event...(p_event)
