from panda3d.core import PGTop, PandaNode
import guiBuildFromEGG
import __builtin__


if __name__=='__main__':
   from direct.showbase.ShowBase import ShowBase
   app=ShowBase('main_app')#need init render2d

 

#=================================================================
#=================================================================

class guiRoot(PGTop): #GUI class mast be used instead of aspect2d
   LayoutList={}
   activeLayout=None
   
   def __init__(self, setup_from='empty', layout='main'):
      setup_from=str(setup_from)
      if setup_from is 'empty':
         print '-+ no file path obtained +-'
         return
      if loadGui(setup_from):
         print '-+ wrong file content +-'
         return
      
      name='gui'
      PGTop.__init__(self, name)
      self.setTransform(aspect2d.node().getTransform())
      __builtin__.__dict__[name]=render2d.attachNewNode(self)
         self.setLayout(layout)

   def setLayout(self, layout):
      layout=str(layout)
      if layout in self.LayoutList:
         self.activeLayout=layout
         self.removeAllChildren()
         self.addChild(self.LayoutList[layout])
      else:
         print '-+ wrong layout name : ', layout, '+-'

   def addLayouts(self, file_path):
      file_path=str(file_path)
      if file_path[-3:]=='cfg':
         print 'setup from CFG file'
         guiBuildFromCfg.buildFromCfg(file_path, self.LayoutList)
         return
      elif file_path[-3:]=='egg':
         print 'setup from EGG file'
         guiBuildFromEGG.buildFromEgg(file_path, self.LayoutList)
         return
      elif file_path[-3:]=='dat':
         print 'loading from DAT file'
         guiBuildFromDat.buildFromDat(file_path, self.LayoutList)
         return
      print '-+ wrong file type +-'
      return True

   def loadGui(self, file_path):
      self.removeAllChildren()
      self.LayoutList={}
      if self.addLayouts(file_path): return True

   def saveGui(self):
      pass



   #_____________________ internal part _______________________
  
   def __loadGui(self, data_path):
      pass


  
#=================================================================
#=================================================================

if __name__=='__main__':
   guiRoot(setup_from='./test_template.egg')   
