from panda3d.core import PGTop, NodePath
import __builtin__


if __name__=='__main__':
   from direct.showbase.ShowBase import ShowBase
   app=ShowBase('main_app') #need init render2d

class treeView(PGTop):
   RootList={}
   name='myTree'
   def __init__(self, setup_from='empty'):
      PGTop.__init__(self, self.name)
      self.setTransform(aspect2d.node().getTransform())
      __builtin__.__dict__[self.name]=render2d.attachNewNode(self)
      if setup_from is 'empty':
         print '-+ no file path obtained +-'
         return
      print '--------', myTree.node().getClassType(), '---------'
      self.setupTree(setup_from)


 
   def setRoot(self):
      self.removeAllChildren()
      self.addChild(self.RootList[Root])

   def saveTree(self):
      pass

   def setupTree(self, file_path):
      file_path=str(file_path)
      if file_path[-3:]=='cfg':
         print 'setup from CFG file'
         self._buildGFG(file_path)
         return True
      elif file_path[-3:]=='egg':
         print 'setup from EGG file'
         self._buildEGG(file_path)
         return True
      elif file_path[-3:]=='dat':
         print 'loading from DAT file'
         self._loadTree(file_path)
         return True
      print '-+ wrong file type +-'

   def treeView(self, np_base=None, tab=':..', npLimit=[100], indx=[0]):
      if np_base==None: np_base=self.Tree_data
      info_set={'name':None, 'cls':None, 'prs':None}
      pn_gn=np_base.node()
      if pn_gn.hasName():
         info_set['name']=str(pn_gn.getName())
      else:
         info_set['name']=str(pn_gn.getClassType())+str(indx[0])
         pn_gn.setName(info_set['name'])
         indx[0]+=1
      info_set['cls']='('+str(np_base.getClassType())+'-->'+str(pn_gn.getClassType())+')'
      info_set['prs']=str(pn_gn.getTransform())[:-1]
      #______________________ info out ____________________________
      print tab, info_set['name'], info_set['cls'],'\n',' '*len(tab), info_set['prs']
      #__________________________________________________________
      if npLimit[0]<1 : return
      np_children=np_base.getChildren().getPaths()
      if not len(np_children): return
      tab=' '*(len(info_set['name'])/2+3)+tab
      npLimit[0]-=1
      for itm in np_children:
         self.treeView(np_base=itm, tab=tab, npLimit=npLimit, indx=indx)

   def viewChildren(self, np_base=None, tab=':..', npLimit=[100]):
      if np_base==None: np_base=self.Tree_data
      print tab, (np_base.node().getClassType() if np_base.getName()=='' else np_base.getName())
      if npLimit[0]<1 : return
      np_children=np_base.getChildren().getPaths()
      if len(np_children)==0: return
      print '    Children:'
      for itm in np_children:
         print '    --', itm
      npLimit[0]-=1
      for itm in np_children:
         self.viewChildren(np_base=itm, npLimit=npLimit)

   
   def treeExplode(self, obj_bank, _pn_=None):
      if _pn_==None: _pn_=self.Tree_data.node()
      if not _pn_.hasName():
         print '-+ tree is unnamed nodes'
         return True
      obj_name=str(_pn_.getName())
      obj_prnt=str(_pn_.getParent(0).getName()) if _pn_.getNumParents() else None
      obj_bank[obj_name]={'obj':_pn_, 'prnt':obj_prnt}
      num_children=_pn_.getNumChildren()
      if not num_children: return
      for indx in range(num_children):
         pn_child=_pn_.getChild(indx)
         if self.treeExplode(obj_bank, _pn_=pn_child): break
      _pn_.removeAllChildren()
      return False


   def treePack(self, obj_bank):
      del_items=[]
      gn_new={}
      for key, gn_src in obj_bank.iteritems() :
         if 'GeomNode' in key:
            pn_src=obj_bank[gn_src['prnt']]
            if pn_src['obj'].isGeomNode(): continue
            #________newName__________oldObj________newPrnt_____
            gn_tmp={gn_src['prnt']:{'obj':gn_src['obj'],'prnt':pn_src['prnt']}}
            gn_ttmp=gn_tmp[gn_src['prnt']]
            #____remember current Geom and his parent______
            if key not in del_items: del_items.append(key)
            if gn_src['prnt'] not in del_items: del_items.append(gn_src['prnt'])
            gn_ttmp['obj'].setName(gn_src['prnt'])
            gn_ttmp['obj'].copyTags(pn_src['obj'])
            gn_ttmp['obj'].setTransform(pn_src['obj'].getTransform())
            #____create bank of corrected nodes for replacement________
            gn_new.update(gn_tmp)
      #___remove old nodes____         
      for itm in del_items:
         obj_bank.pop(itm)
      #___add new correct nodes____
      obj_bank.update(gn_new)
      self.__treeResurect(obj_bank)
   

   def __treeResurect(self, obj_bank):
      for node in obj_bank.itervalues():
         node['obj']=NodePath(node['obj'])
      for node in obj_bank.itervalues():
         if node['prnt']==None:
            self.Tree_data=node['obj']
         elif node['prnt']=='myTree':# if model is initialy parented
            self.Tree_data=node['obj']
         else: node['obj'].reparentTo(obj_bank[node['prnt']]['obj'])
         

   def findByName(self, np_base=None, name=None, targets=[]):
      mask=str(name)
      if mask is 'None' : return 'Find mask is not specified'
      if np_base==None:
         np_base=self.Tree_data
         print np_base.getName(), ' contain this \"', mask, '\" nodes:'
      #targets=[]
      if mask in np_base.getName():
         targets.append(np_base)
      print 'test info: ', np_base.getName(), '==',targets
      np_children=np_base.getChildren().getPaths()
      if len(np_children)==0: return 
      for itm in np_children:
         self.findByName( np_base=itm, name=mask, targets=targets)
         
   def getNodes(self, nodes_list, pn=None):
      if pn==None: pn=self.Tree_data.node() # 1raz
      if not len(nodes_list): nodes_list.append(pn) # 1raz
      num_children=pn.getNumChildren()
      if not num_children: return
      for indx in range(num_children):
         nodes_list.append(pn.getChild(indx))
      for indx in range(num_children):
         self.getNodes(nodes_list=nodes_list, pn=pn.getChild(indx))      
      
      
#------------------ internal part ------------------------
   def _buildCFG(self, cfg_path):
      pass

   def _loadTree(self, data_path):
      pass

   def _buildEGG(self, egg_path):
      self.Tree_data=loader.loadModel(egg_path)
      self.Tree_data.setScale(0.1)
      listNP=self.Tree_data.getNodes()
      #_____ now the root of the model have parent _____ 
      self.Tree_data.reparentTo(myTree)

   def _Debug_(self, info=''):
      if len(info):
         if info=='Tree':
            print '======Original tree ====================='
            self.treeView()
         if info=='Children':
            print '======Children ========================'
            self.viewChildren()
         if info=='Nodes':
            print '======All Nodes ========================'
            self.treeView()
            nodesList=[]
            self.getNodes(nodesList)
            print
            for node in nodesList:
               print str(node)[:-1], (' *** geom node ***' if node.isGeomNode() else '')
         if info=='Pack':
            self.treeView()
            print '===== Explode data ====================='
            obj_bank={}
            self.treeExplode(obj_bank)
            #for key in obj_bank: print key, ': ', obj_bank[key]
            print '===== Pack object data =================='
            self.treePack(obj_bank)
            print '===== New Tree ========================'
            self.treeView()
            print '====================================='

#==========================================================
#==========================================================

if __name__=='__main__':
   mng=treeView(setup_from='./tree_mdl.egg')
   mng._Debug_('Nodes')
   app.run()
